Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/PushStack.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/PushStack.cs	(revision 14744)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/PushStack.cs	(revision 14744)
@@ -0,0 +1,280 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Stack {
+  using System;
+  using System.Collections;
+  using System.Collections.Generic;
+  using System.Linq;
+
+  /// <summary>
+  ///     While Push's stacks are generally treated as genuine stacks---that is, inclassions take their arguments from the
+  ///     tops of
+  ///     the stacks and push their results onto the tops of the stacks---a few inclassions (like YANK and SHOVE) do allow
+  ///     direct access
+  ///     to "deep" stack elements by means of integer indices. To this extent the stacks can be used as general, random
+  ///     access memory
+  ///     classures. This is one of the features that ensures the Turing-completeness of Push (another being the arbitrary
+  ///     name/value
+  ///     bindings supported by the NAME data type and DEFINE methods; see below).
+  /// </summary>
+  /// <typeparam name="T">The item type of the collection.</typeparam>
+  public class PushStack<T> : IStack<T> {
+    private const string Delimiter = " ";
+
+    private readonly List<T> data;
+
+    public PushStack(int capacity = 0) {
+      data = new List<T>(capacity);
+      IsEnabled = true;
+    }
+
+    public bool IsEnabled { get; set; }
+
+    public int Capacity
+    {
+      get
+      {
+        return this.data.Capacity;
+      }
+    }
+
+    public T Top
+    {
+      get
+      {
+        return this.data[this.Count - 1];
+      }
+    }
+
+    public T TopOrDefault
+    {
+      get
+      {
+        return this.Count > 0 ? this.data[this.Count - 1] : default(T);
+      }
+    }
+
+    public T Bottom
+    {
+      get
+      {
+        return this.data[0];
+      }
+    }
+
+    public T BottomOrDefault
+    {
+      get
+      {
+        return this.Count > 0 ? this.data[0] : default(T);
+      }
+    }
+
+    public int Count
+    {
+      get
+      {
+        return this.data.Count;
+      }
+    }
+
+    public bool IsEmpty
+    {
+      get
+      {
+        return this.Count == 0;
+      }
+    }
+
+    public bool IsReadOnly
+    {
+      get
+      {
+        return false;
+      }
+    }
+
+    public void Add(T item) {
+      this.Push(item);
+    }
+
+    public void Clear() {
+      this.data.Clear();
+    }
+
+    public bool Contains(T item) {
+      return this.data.Contains(item);
+    }
+
+    public void CopyTo(T[] array, int arrayIndex) {
+      this.data.CopyTo(array, arrayIndex);
+    }
+
+    public IEnumerator<T> GetEnumerator() {
+      return this.data.GetEnumerator();
+    }
+
+    public T ElementAt(int index) {
+      return this.data[index];
+    }
+
+    public T ReverseElementAt(int offset) {
+      return this.data[this.data.Count - 1 - offset];
+    }
+
+    public void SetTop(T value) {
+      this.data[this.Count - 1] = value;
+    }
+
+    public T this[int key]
+    {
+      get
+      {
+        return this.data[key];
+      }
+      set
+      {
+        this.data[key] = value;
+      }
+    }
+
+    public void Swap(int count) {
+      var top = this.Top;
+      var bottomIndex = this.Count - count;
+
+      for (var i = this.Count - 1; i > bottomIndex; i--) this.data[i] = this.data[i - 1];
+
+      this.data[bottomIndex] = top;
+    }
+
+    public void Yank(int index) {
+      if (index == this.Count - 1) return;
+
+      var item = this.ElementAt(index);
+      this.data.RemoveAt(index);
+      this.data.Add(item);
+    }
+
+    public T Pop() {
+      var value = this.data[this.Count - 1];
+      this.data.RemoveAt(this.Count - 1);
+
+      return value;
+    }
+
+    public T[] Pop(int count) {
+      var items = Peek(count);
+      this.Remove(count);
+
+      return items;
+    }
+
+    public T Peek() {
+      return Top;
+    }
+
+    public T[] Peek(int count) {
+      var startIndex = this.Count - count;
+
+      var items = new T[count];
+      this.data.CopyTo(startIndex, items, 0, count);
+
+      return items;
+    }
+
+    public void Push(T item) {
+      if (!IsEnabled) return;
+
+      this.data.Add(item);
+    }
+
+    public void PushResult(int count, Func<T[], T> templateFunc) {
+      if (!IsEnabled) return;
+
+      var startIndex = this.Count - count;
+      var items = new T[count];
+
+      this.data.CopyTo(startIndex, items, 0, count);
+      this.Remove(count - 1);
+
+      this.data[this.Count - 1] = templateFunc(items);
+    }
+
+    public void Push(params T[] items) {
+      if (!IsEnabled) return;
+
+      for (var i = 0; i < items.Length; i++) this.data.Add(items[i]);
+      //this.data.AddRange(items);
+    }
+
+    public void ReversePush(params T[] items) {
+      for (var i = items.Length - 1; i >= 0; i--) this.data.Add(items[i]);
+    }
+
+    public void Push(IReadOnlyList<T> items) {
+      if (!IsEnabled) return;
+
+      for (var i = 0; i < items.Count; i++) this.data.Add(items[i]);
+      //this.data.AddRange(items);
+    }
+
+    public void Insert(int index, T item) {
+      if (!IsEnabled) return;
+
+      this.data.Insert(index, item);
+    }
+
+    public void Insert(int index, params T[] items) {
+      if (!IsEnabled) return;
+
+      this.data.InsertRange(index, items);
+    }
+
+    public void Insert(int index, IEnumerable<T> items) {
+      if (!IsEnabled) return;
+
+      this.data.InsertRange(index, items);
+    }
+
+    public bool Remove(T item) {
+      var index = this.Count - 1;
+      if ((this.Count > 0) && this.data[index].Equals(item)) {
+        this.data.RemoveAt(index);
+        return true;
+      }
+      return false;
+    }
+
+    public void RemoveTop() {
+      this.data.RemoveAt(this.Count - 1);
+    }
+
+    public void Remove(int count) {
+      for (var i = 0; i < count; i++) this.data.RemoveAt(this.Count - 1);
+    }
+
+    public void RemoveAt(int index) {
+      this.data.RemoveAt(index);
+    }
+
+    public void RemoveAt(int index, int count) {
+      this.data.RemoveRange(index, count);
+    }
+
+    public bool TryPop(out T item) {
+      if (this.Count > 0) {
+        item = this.Pop();
+        return true;
+      }
+      item = default(T);
+      return false;
+    }
+
+    IEnumerator IEnumerable.GetEnumerator() {
+      return data.GetEnumerator();
+    }
+
+    public override string ToString() {
+      var data = this.data as IEnumerable<T>;
+      return string.Join(Delimiter, data.Reverse());
+    }
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/PushProgramDebuggerView.Designer.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/PushProgramDebuggerView.Designer.cs	(revision 14733)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/PushProgramDebuggerView.Designer.cs	(revision 14744)
@@ -26,5 +26,5 @@
       System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(PushProgramDebuggerView));
       this.execGroupBox = new System.Windows.Forms.GroupBox();
-      this.execList = new System.Windows.Forms.ListBox();
+      this.execList = new System.Windows.Forms.ListView();
       this.integerGroupBox = new System.Windows.Forms.GroupBox();
       this.integerList = new System.Windows.Forms.ListBox();
@@ -44,4 +44,5 @@
       this.stepWidthBox = new System.Windows.Forms.NumericUpDown();
       this.runButton = new System.Windows.Forms.Button();
+      this.skipNoopsCheckBox = new System.Windows.Forms.CheckBox();
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
       this.execGroupBox.SuspendLayout();
@@ -83,11 +84,11 @@
             | System.Windows.Forms.AnchorStyles.Left)
             | System.Windows.Forms.AnchorStyles.Right)));
-      this.execList.FormattingEnabled = true;
-      this.execList.HorizontalScrollbar = true;
-      this.execList.Location = new System.Drawing.Point(7, 20);
+      this.execList.Location = new System.Drawing.Point(3, 16);
       this.execList.Name = "execList";
-      this.execList.SelectionMode = System.Windows.Forms.SelectionMode.None;
-      this.execList.Size = new System.Drawing.Size(231, 602);
-      this.execList.TabIndex = 0;
+      this.execList.Size = new System.Drawing.Size(235, 605);
+      this.execList.TabIndex = 1;
+      this.execList.UseCompatibleStateImageBehavior = false;
+      this.execList.View = System.Windows.Forms.View.List;
+      this.execList.VirtualMode = true;
       //
       // integerGroupBox
@@ -254,6 +255,5 @@
       // exampleComboBox
       //
-      this.exampleComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-            | System.Windows.Forms.AnchorStyles.Left)
+      this.exampleComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
             | System.Windows.Forms.AnchorStyles.Right)));
       this.exampleComboBox.FormattingEnabled = true;
@@ -325,8 +325,22 @@
       this.runButton.UseVisualStyleBackColor = true;
       //
+      // skipNoopsCheckBox
+      //
+      this.skipNoopsCheckBox.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
+      this.skipNoopsCheckBox.AutoSize = true;
+      this.skipNoopsCheckBox.Checked = true;
+      this.skipNoopsCheckBox.CheckState = System.Windows.Forms.CheckState.Checked;
+      this.skipNoopsCheckBox.Location = new System.Drawing.Point(150, 704);
+      this.skipNoopsCheckBox.Name = "skipNoopsCheckBox";
+      this.skipNoopsCheckBox.Size = new System.Drawing.Size(81, 17);
+      this.skipNoopsCheckBox.TabIndex = 11;
+      this.skipNoopsCheckBox.Text = "Skip NOOP";
+      this.skipNoopsCheckBox.UseVisualStyleBackColor = true;
+      //
       // PushProgramDebuggerView
       //
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.skipNoopsCheckBox);
       this.Controls.Add(this.runButton);
       this.Controls.Add(this.stepWidthBox);
@@ -348,4 +362,5 @@
       this.Controls.SetChildIndex(this.stepWidthBox, 0);
       this.Controls.SetChildIndex(this.runButton, 0);
+      this.Controls.SetChildIndex(this.skipNoopsCheckBox, 0);
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
       this.execGroupBox.ResumeLayout(false);
@@ -370,5 +385,4 @@
     private System.Windows.Forms.GroupBox booleanGroupBox;
     private System.Windows.Forms.GroupBox nameGroupBox;
-    private System.Windows.Forms.ListBox execList;
     private System.Windows.Forms.ListBox integerList;
     private System.Windows.Forms.ListBox floatList;
@@ -383,4 +397,6 @@
     private System.Windows.Forms.NumericUpDown stepWidthBox;
     private System.Windows.Forms.Button runButton;
+    private System.Windows.Forms.CheckBox skipNoopsCheckBox;
+    private System.Windows.Forms.ListView execList;
   }
 }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/PushProgramDebuggerView.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/PushProgramDebuggerView.cs	(revision 14733)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/PushProgramDebuggerView.cs	(revision 14744)
@@ -8,14 +8,21 @@
   using System.Linq;
 
-  using HeuristicLab.BenchmarkSuite.Problems;
+  using HeuristicLab.BenchmarkSuite;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Problem;
+  using HeuristicLab.Random;
 
   [View("Push Program Debugger")]
   [Content(typeof(PushSolution), true)]
   public partial class PushProgramDebuggerView : NamedItemView {
+    private const string Separator = ", ";
+    private PushProgram program;
+
+    private ListViewItem[] execListCache; //array to cache items for the virtual list
+    private int firstExecListItemIndex; //stores the index of the first item in the cache
+
     private const string exampleSplitter = " => ";
-    private PushGpInterpreter interpreter;
+    private PushInterpreter interpreter;
 
     public PushProgramDebuggerView() {
@@ -28,9 +35,80 @@
       resetButton.Click += ResetButtonClick;
       stepButton.Click += StepButtonClick;
-    }
-
-    protected override void OnReadOnlyChanged() {
-      base.OnReadOnlyChanged();
-
+
+      execList.RetrieveVirtualItem += ExecListRetrieveVirtualItem;
+      execList.CacheVirtualItems += ExecListCacheVirtualItems;
+
+      execList.View = View.Details;
+      execList.HeaderStyle = ColumnHeaderStyle.Nonclickable;
+      execList.AutoResizeColumns(ColumnHeaderAutoResizeStyle.None);
+      execList.Columns.Add(new ColumnHeader { Width = execList.Width - 40 });
+      execList.VirtualMode = true;
+      execList.VirtualListSize = 100;
+    }
+
+    private void ExecListCacheVirtualItems(object sender, CacheVirtualItemsEventArgs e) {
+      //We've gotten a request to refresh the cache.
+      //First check if it's really neccesary.
+      if (execListCache != null &&
+        e.StartIndex >= firstExecListItemIndex &&
+        e.EndIndex <= firstExecListItemIndex + execListCache.Length) {
+        //If the newly requested cache is a subset of the old cache,
+        //no need to rebuild everything, so do nothing.
+        return;
+      }
+
+      //Now we need to rebuild the cache.
+      UpdateListCache(e.StartIndex, e.EndIndex);
+    }
+
+    private void ExecListRetrieveVirtualItem(object sender, RetrieveVirtualItemEventArgs e) {
+      //check to see if the requested item is currently in the cache
+      if (execListCache == null ||
+        e.ItemIndex < firstExecListItemIndex ||
+        e.ItemIndex >= firstExecListItemIndex + execListCache.Length) {
+        UpdateListCache(e.ItemIndex, execList.VirtualListSize);
+      }
+
+      e.Item = e.ItemIndex >= firstExecListItemIndex && e.ItemIndex < firstExecListItemIndex + execListCache.Length
+          ? execListCache[e.ItemIndex - firstExecListItemIndex]
+          : e.Item = new ListViewItem();
+    }
+
+    private void UpdateListCache(int startIndex, int endIndex) {
+      if (interpreter == null) {
+        execListCache = new ListViewItem[0];
+        return;
+      }
+
+      this.firstExecListItemIndex = startIndex;
+      var length = Math.Min(endIndex - startIndex + 1, interpreter.ExecStack.Count); //indexes are inclusive
+      this.execListCache = new ListViewItem[length];
+
+      var expressions = this.interpreter.ExecStack.Peek(length);
+
+      //Fill the cache with the appropriate ListViewItems.
+      for (var i = 0; i < length; i++)
+        this.execListCache[i] = new ListViewItem(expressions[length - 1 - i].ToString());
+
+      execList.AutoResizeColumns(ColumnHeaderAutoResizeStyle.None);
+      execList.AutoResizeColumns(ColumnHeaderAutoResizeStyle.ColumnContent);
+    }
+
+    //protected override void OnEnabledChanged(EventArgs e) {
+    //  SetReadonlyFields();
+    //}
+
+    //protected override void OnReadOnlyChanged() {
+    //  base.OnReadOnlyChanged();
+
+    //  SetReadonlyFields();
+    //}
+
+    //protected override void SetEnabledStateOfControls()
+    //{
+    //  SetReadonlyFields();
+    //}
+
+    private void SetReadonlyFields() {
       exampleComboBox.Enabled = !ReadOnly;
       execList.Enabled = !ReadOnly;
@@ -40,4 +118,9 @@
       floatList.Enabled = !ReadOnly;
       booleanList.Enabled = !ReadOnly;
+      stepButton.Enabled = !ReadOnly;
+      runButton.Enabled = !ReadOnly;
+      resetButton.Enabled = !ReadOnly;
+      skipNoopsCheckBox.Enabled = !ReadOnly;
+      stepWidthBox.Enabled = !ReadOnly;
     }
 
@@ -54,11 +137,7 @@
 
     private void SyncExecList() {
-      execList.Items.RemoveAt(0);
-
-      if (!interpreter.ExecStack.SequenceEqual(execList.Items.Cast<Expression>().Reverse())) {
-        UpdateExecList();
-      }
-
-      this.execGroupBox.Text = string.Format("Exec [{0}]", this.execList.Items.Count);
+      UpdateExecList();
+
+      this.execGroupBox.Text = string.Format("Exec [{0}]", this.interpreter.ExecStack.Count);
     }
 
@@ -70,5 +149,12 @@
 
       for (var i = 0; i < count; i++) {
-        interpreter.Step();
+        if (skipNoopsCheckBox.Checked) {
+          bool noop;
+
+          do {
+            noop = !interpreter.Step();
+          }
+          while (interpreter.CanStep && noop);
+        } else interpreter.Step();
       }
 
@@ -114,5 +200,5 @@
       interpreter.Clear();
 
-      var example = Content.Data.Examples[this.exampleComboBox.SelectedIndex];
+      var example = Content.DataDescriptor.Examples[this.exampleComboBox.SelectedIndex];
 
       interpreter.BooleanStack.Push(example.InputBoolean);
@@ -120,5 +206,5 @@
       interpreter.FloatStack.Push(example.InputFloat);
 
-      interpreter.Run(Content.Program, true);
+      interpreter.Run(program, true);
       stepWidthBox.Maximum = interpreter.ExecStack.Count;
 
@@ -131,7 +217,9 @@
       if (Content == null) return;
 
-      interpreter = Content.Pool.GetInstance(Content.Random);
-
-      UpdateExamples(Content.Data);
+      var random = Content.Random ?? new FastRandom();
+      interpreter = new PushInterpreter(Content.Config, random);
+      program = Content.IntegerVector.MapToPushProgram(Content.Config.EnabledExpressions);
+
+      UpdateExamples(Content.DataDescriptor);
 
       if (this.exampleComboBox.SelectedIndex < 0) {
@@ -151,8 +239,6 @@
 
     private void UpdateExecList() {
-      execList.Items.Clear();
-
-      foreach (var item in interpreter.ExecStack.Reverse())
-        this.execList.Items.Add(item);
+      UpdateListCache(0, execList.VirtualListSize);
+      execList.Update();
 
       this.execGroupBox.Text = string.Format("Exec [{0}]", this.execList.Items.Count);
@@ -226,10 +312,11 @@
     }
 
-    private void UpdateExamples(Data data) {
-      const string seperator = ", ";
+    private void UpdateExamples(IBenchmarkSuiteDataDescriptor data) {
+      if (data == null) return;
+
       var stringRepresentations = data.Examples.Select(e =>
-        string.Join(seperator, e.InputArgs) +
+        string.Join(Separator, e.InputArgs) +
         exampleSplitter +
-        string.Join(seperator, e.OutputArgs));
+        string.Join(Separator, e.OutputArgs));
 
       exampleComboBox.Items.Clear();
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Benchmark/ProblemTests.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Benchmark/ProblemTests.cs	(revision 14733)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Benchmark/ProblemTests.cs	(revision 14744)
@@ -9,4 +9,5 @@
   using HeuristicLab.Problems.Instances;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Configuration;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Data.Pool;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Generators;
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/ExpressionTest.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/ExpressionTest.cs	(revision 14733)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/ExpressionTest.cs	(revision 14744)
@@ -6,5 +6,5 @@
 
   public class ExpressionTest {
-    protected PushGpInterpreter interpreter;
+    protected PushInterpreter interpreter;
 
     protected PushConfiguration configuration = new PushConfiguration { TopLevelPushCode = false };
@@ -12,5 +12,5 @@
     [TestInitialize]
     public void BeforeTest() {
-      this.interpreter = new PushGpInterpreter(configuration);
+      this.interpreter = new PushInterpreter(configuration);
     }
 
Index: branches/PushGP/HeuristicLab.PushGP/PushGP.Cli/Program.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/PushGP.Cli/Program.cs	(revision 14733)
+++ branches/PushGP/HeuristicLab.PushGP/PushGP.Cli/Program.cs	(revision 14744)
@@ -18,7 +18,7 @@
       //Stepwise().Wait();
       //PerformanceTestInterpreter();
-      PerformanceParallelTestInterpreter();
+      //PerformanceParallelTestInterpreter();
       //PerformanceTestCodeGenerator();
-      //TestRobustness();
+      TestRobustness();
       //TestPool();
       //TestPoolPerformance();
@@ -36,5 +36,5 @@
 
     static async Task EvaluateStepwise(string code) {
-      var interpreter = new PushGpInterpreter(new PushConfiguration {
+      var interpreter = new PushInterpreter(new PushConfiguration {
         TopLevelPushCode = false
       });
@@ -60,5 +60,5 @@
 
     static void SimpleTest() {
-      var interpreter = new PushGpInterpreter();
+      var interpreter = new PushInterpreter();
 
       interpreter.Run("5 INTEGER.DUP INTEGER.+");
@@ -68,5 +68,5 @@
 
     static async Task Stepwise() {
-      var interpreter = new PushGpInterpreter();
+      var interpreter = new PushInterpreter();
 
       interpreter.RunAsync("( 0 2 CODE.QUOTE ( 1 INTEGER.+ 0 3 CODE.QUOTE ( 1 INTEGER.+ INTEGER.* ) CODE.DO*RANGE INTEGER.+ ) CODE.DO*RANGE )", true).Wait();
@@ -92,5 +92,5 @@
       var program = PushParser.Parse("( 5 INTEGER.DUP INTEGER.+ )");
 
-      var interpreter = new PushGpInterpreter();
+      var interpreter = new PushInterpreter();
       var sw = new Stopwatch();
 
@@ -149,14 +149,14 @@
       var parallelism = Environment.ProcessorCount;
       var maxProgramSizeLimit = 1024;
-      var partitionSize = 1000;
+      var partitionSize = 10000;
       var execCounters = new int[parallelism];
 
       var config = new PushConfiguration {
         EvalPushLimit = 4096,
-        //IsCodeStackEnabled = false,
-        IsExecStackEnable = false,
-        IsBooleanStackEnabled = false,
-        IsFloatStackEnabled = false,
-        IsIntegerStackEnabled = false,
+        IsCodeStackEnabled = false,
+        //IsExecStackEnable = false,
+        //IsBooleanStackEnabled = false,
+        //IsFloatStackEnabled = false,
+        //IsIntegerStackEnabled = false,
         IsNameStackEnabled = false,
       };
@@ -166,5 +166,5 @@
       sw.Start();
       Parallel.For(0, parallelism, i => {
-        var random = new FastRandom(1337);
+        var random = new MersenneTwister(1337);
         using (var interpreter = pool.GetInstance(random)) {
           for (var j = 0; j < partitionSize; j++) {
@@ -186,5 +186,5 @@
     static void TestPool() {
       var pool = new PushInterpreterPool();
-      var normal = new PushGpInterpreter();
+      var normal = new PushInterpreter();
       int id;
 
@@ -210,5 +210,5 @@
       sw.Start();
       for (var i = 0; i < iterations; i++) {
-        var interpreter = new PushGpInterpreter();
+        var interpreter = new PushInterpreter();
         interpreter.Clear();
       }
@@ -230,7 +230,7 @@
 
     static void TestSimplifier() {
-      var interpreter = new PushGpInterpreter();
+      var interpreter = new PushInterpreter();
       var program = PushParser.Parse("( 5 INTEGER.DUP FLOAT.+ INTEGER.+ )") as ExecExpandExpression;
-      var simplifier = new RandomSimplifier() { Trys = 10 };
+      var simplifier = new RandomSimplifier { Trys = 10 };
       var random = new FastRandom(1337);
 
Index: branches/PushGP/HeuristicLab.PushGP/PushGp.sln
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/PushGp.sln	(revision 14733)
+++ branches/PushGP/HeuristicLab.PushGP/PushGp.sln	(revision 14744)
@@ -11,4 +11,6 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.ProgramSynthesis", "HeuristicLab.Problems.ProgramSynthesis\HeuristicLab.Problems.ProgramSynthesis.csproj", "{5C93448C-47E3-4C3F-B1D0-EE62A48C3204}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "TestPooling", "TestPooling\TestPooling.csproj", "{B184A849-1403-4F5F-96F8-952C6599A7C0}"
 EndProject
 Global
@@ -34,4 +36,8 @@
 		{5C93448C-47E3-4C3F-B1D0-EE62A48C3204}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{5C93448C-47E3-4C3F-B1D0-EE62A48C3204}.Release|Any CPU.Build.0 = Release|Any CPU
+		{B184A849-1403-4F5F-96F8-952C6599A7C0}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{B184A849-1403-4F5F-96F8-952C6599A7C0}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{B184A849-1403-4F5F-96F8-952C6599A7C0}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{B184A849-1403-4F5F-96F8-952C6599A7C0}.Release|Any CPU.Build.0 = Release|Any CPU
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
Index: branches/PushGP/HeuristicLab.PushGP/TestPooling/Pool/ManagedPool.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/TestPooling/Pool/ManagedPool.cs	(revision 14744)
+++ branches/PushGP/HeuristicLab.PushGP/TestPooling/Pool/ManagedPool.cs	(revision 14744)
@@ -0,0 +1,58 @@
+﻿using System.Collections.Generic;
+
+namespace TestPooling.Pool {
+  using System;
+  using System.Collections.Concurrent;
+  using System.Linq;
+
+  public class ManagedPool<T> : IDisposable where T : class {
+
+    private static readonly ConcurrentStack<LinkedList<T>> Pool = new ConcurrentStack<LinkedList<T>>();
+    private readonly Func<T> Factory;
+    public readonly int PartitionSize;
+
+    private readonly IList<LinkedList<T>> partitions = new List<LinkedList<T>>();
+    private LinkedList<T> currentPartition;
+    private LinkedListNode<T> currentNode;
+
+    private int entryIndex = 0;
+
+    public ManagedPool(int partitionSize, Func<T> factory) {
+      PartitionSize = partitionSize;
+      Factory = factory;
+    }
+
+    public T Get() {
+      if (currentPartition == null || entryIndex == PartitionSize) {
+        currentPartition = GetPartition();
+        currentNode = currentPartition.First;
+        entryIndex = 0;
+
+        partitions.Add(currentPartition);
+      }
+
+      T entry;
+      if (currentNode == null) {
+        entry = Factory();
+        currentPartition.AddLast(entry);
+      } else {
+        entry = currentNode.Value;
+        currentNode = currentNode.Next;
+      }
+
+      entryIndex++;
+
+      return entry;
+    }
+
+    private LinkedList<T> GetPartition() {
+      LinkedList<T> partition;
+
+      return Pool.TryPop(out partition) ? partition : new LinkedList<T>();
+    }
+
+    public void Dispose() {
+      Pool.PushRange(partitions.ToArray());
+    }
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/TestPooling/Pool/ManagedPool2.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/TestPooling/Pool/ManagedPool2.cs	(revision 14744)
+++ branches/PushGP/HeuristicLab.PushGP/TestPooling/Pool/ManagedPool2.cs	(revision 14744)
@@ -0,0 +1,75 @@
+﻿using System.Collections.Generic;
+
+namespace TestPooling.Pool {
+  using System;
+  using System.Collections.Concurrent;
+  using System.IO;
+  using System.Linq;
+  using System.Runtime.Serialization.Formatters.Binary;
+
+  public class ManagedPool2<T> : IDisposable where T : class {
+
+    private static readonly ConcurrentStack<T[]> Pool = new ConcurrentStack<T[]>();
+
+    private readonly T[] DummyPartition;
+    private readonly Func<T> Factory;
+    public readonly int PartitionSize;
+
+    private readonly IList<T[]> partitions = new List<T[]>();
+    private T[] currentPartition;
+    private int entryIndex;
+
+    public ManagedPool2(int partitionSize, T[] dummyPartition, Func<T> factory) {
+      PartitionSize = partitionSize;
+      Factory = factory;
+      entryIndex = partitionSize;
+
+      DummyPartition = dummyPartition;
+    }
+
+    public T Get() {
+      if (entryIndex == PartitionSize) {
+        currentPartition = GetPartition();
+        partitions.Add(currentPartition);
+        entryIndex = 0;
+      }
+
+      return currentPartition[entryIndex++];
+    }
+
+    private T[] GetPartition() {
+      //T[] partition;
+
+      //partition = Pool.TryPop(out partition) ? partition : new T[PartitionSize];
+
+      //for (var i = 0; i < PartitionSize; i++) {
+      //  partition[i] = Factory();
+      //}
+
+      //return partition;
+
+      T[] partition;
+      if (Pool.TryPop(out partition)) return partition;
+
+      //partition = new T[PartitionSize];
+      //DummyPartition.CopyTo(partition, 0);
+
+      return DeepArrayCopy(DummyPartition);
+    }
+
+    private static T[] DeepArrayCopy(object objectToCopy) {
+      using (var memoryStream = new MemoryStream()) {
+        var binaryFormatter = new BinaryFormatter();
+
+        binaryFormatter.Serialize(memoryStream, objectToCopy);
+        memoryStream.Seek(0, SeekOrigin.Begin);
+
+        return (T[])binaryFormatter.Deserialize(memoryStream);
+      }
+    }
+
+    public void Dispose() {
+      Pool.PushRange(partitions.ToArray());
+    }
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/TestPooling/Pool/ManagedPoolProvider.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/TestPooling/Pool/ManagedPoolProvider.cs	(revision 14744)
+++ branches/PushGP/HeuristicLab.PushGP/TestPooling/Pool/ManagedPoolProvider.cs	(revision 14744)
@@ -0,0 +1,45 @@
+﻿//using System;
+
+//namespace TestPooling.Pool {
+//  using System.Collections.Concurrent;
+//  using System.Threading.Tasks;
+
+//  public class ManagedPoolProvider<T> where T : class {
+//    private static readonly volatile ConcurrentStack<T[]> partitions = new ConcurrentStack<T[]>();
+//    private readonly Func<T> Factory;
+//    public readonly int PartitionSize;
+
+//    public ManagedPoolProvider(int partitionSize, Func<T> factory) {
+//      PartitionSize = partitionSize;
+//      Factory = factory;
+//    }
+
+//    public T[] GetPartition() {
+//      T[] partition;
+
+//      return partitions.TryPop(out partition) ? partition : CreatePartition();
+//    }
+
+//    public void ReleasePartitions(params T[][] partition) {
+//      partitions.PushRange(partition);
+//    }
+
+//    public T CreateEntry() {
+//      return Factory();
+//    }
+
+//    private T[] CreatePartition() {
+//      //return new T[PartitionSize];
+
+//      var partition = new T[PartitionSize];
+
+//      Parallel.For(0, PartitionSize, i => partition[i] = Factory());
+
+//      return partition;
+//    }
+
+//    public ManagedPool<T> CreatePool() {
+//      return new ManagedPool<T>(this);
+//    }
+//  }
+//}
